require 'active_support/concern'
module Struggle
  module ModelExtend
    extend ActiveSupport::Concern

    included do
      # created_at  updated_at 删除 '+0800'
      # 删除集合中的created_at和updated_at的'+0800'
      scope :to_hash, -> do
        objs = []
        each do |obj|
          objs << obj.to_hash
        end
        objs
      end

      def to_hash
        obj = self.serializable_hash
        obj.each do |k, v|
          if v.class == ActiveSupport::TimeWithZone
            obj[k] = v.localtime.to_s(:db)
          end
        end
        obj
      end

      def upload_crop_image(field, image, x, y, w, h)
        filepath = "uploads/#{self.class.table_name}/#{Time.now.to_date.strftime("%Y%m%d")}"
        file = Struggle::Tfile.imagecropupload(image, "#{Rails.root}/public/#{filepath}/","jpg|bmp|gif|ico|pcx|jpeg|tif|png", 0, 2000, x, y, w, h)
        self[field.to_sym] = file[:state] ? "#{filepath}/#{file[:result]}" : ""
      end

      def delete_image(field)
        unless self[field.to_sym].blank?
          begin
            File.delete("#{Rails.root}/public/#{self[field.to_sym]}")
          rescue
            puts "#{$!}"
          end
        end
      end
    end

    module ClassMethods
    end
  end
end