module Struggle
  class Logistic
    require 'net/https'
    require 'uri'
    require 'json'
    URL = "http://api.kuaidi100.com/api"
    URL_loophold = "http://www.kuaidi100.com/query"

    def self.send(id, com, nu, show="json", muti=1, order="desc")
      respond = Http.new(URL).get({'id' => id, 'com' => com, 'nu' => nu, 'show' => show, 'muti' => muti, 'order' => order})
      puts respond.body
      return respond.body.blank? ? nil : JSON.parse(respond.body)
    end

    def self.sendByLoophold(type, postid)
      respond = Http.new(URL_loophold).post({'type' => type, 'postid' => postid})
      return respond.body.blank? ? nil : JSON.parse(respond.body)
    end

    Company = {"anxindakuaixi" => "安信达","huitongkuaidi" => "百世快递", "baifudongfang" => "百福东方", "bht" => "BHT", "bangsongwuliu" => "邦送物流",
               "coe" => "中国东方（COE）", "chuanxiwuliu" => "传喜物流", "datianwuliu" => "大田物流",
               "debangwuliu" => "德邦物流","dpex" => "DPEX", "dhl" => "DHL-中国件", "dsukuaidi" => "D速快递", "disifang" => "递四方",
               "ems" => "EMS-（中国-中国）件", "feikangda" => "飞康达物流", "feikuaida" => "飞快达", "rufengda" => "凡客如风达",
               "fengxingtianxia" => "风行天下", "feibaokuaidi" => "飞豹快递", "ganzhongnengda" => "港中能达", "guotongkuaidi" => "国通快递", "guangdongyouzhengwuliu" => "广东邮政",
               "youzhengguonei" => "邮政包裹、挂号信-中国件", "gongsuda" => "共速达", "gls" => "GLS", "huiqiangkuaidi"=>"汇强快递",
               "hengluwuliu"=>"恒路物流","huaxialongwuliu"=>"华夏龙","hebeijianhua"=>"河北建华","haimengsudi"=>"海盟速递","huaqikuaiyun"=>"华企快运",
               "haihongwangsong"=>"山东海红","jiajiwuliu"=>"佳吉物流", "jiayiwuliu"=>"佳怡物流","jiayunmeiwuliu"=>"加运美","jinguangsudikuaijian"=>"京广速递","jixianda"=>"急先达","jinyuekuaidi"=>"晋越快递",
               "jietekuaidi"=>"捷特快递","jindawuliu"=>"金大物流", "jialidatong"=>"嘉里大通","kuaijiesudi"=>"快捷速递","kangliwuliu"=>"康力物流","kuayue"=>"跨越物流","lianhaowuliu"=>"联昊通",
               "longbanwuliu"=>"龙邦物流","lanbiaokuaidi"=>"蓝镖快递","lejiedi"=>"乐捷递","lianbangkuaidi" => "联邦快递", "lijisong"=>"立即送",
               "longlangkuaidi"=>"隆浪快递","menduimen"=>"门对门","meiguokuaidi"=>"美国快递","mingliangwuliu"=>"明亮物流","ocs"=>"OCS","ontrac"=>"onTrac","quanchenkuaidi"=>"全晨快递",
               "quanjitong"=>"全际通","quanritongkuaidi"=>"全日通","quanyikuaidi"=>"全一快递","quanfengkuaidi"=>"全峰快递", "sevendays"=>"七天连锁","shentong"=>"申通",
               "shunfeng"=>"顺丰速递","shenghuiwuliu"=>"盛辉物流","suer"=>"速尔物流","shengfengwuliu"=>"盛丰物流","shangda"=>"上大物流",
               "santaisudi"=>"三态速递","saiaodi"=>"赛澳递", "sxhongmajia"=>"山西红马甲","shenganwuliu"=>"圣安物流","suijiawuliu"=>"穗佳物流",
               "tiandihuayu"=>"天地华宇","tiantian"=>"天天快递", "tnt" => "TNT-中文", "ups" => "UPS-中文", "usps" => "USPS", "tonghetianxia"=>"通和天下",
               "youshuwuliu"=>"优速物流", "wanjiawuliu"=>"万家物流", "wanxiangwuliu"=>"万象物流", "weitepai"=>"微特派", "xinbangwuliu"=>"新邦物流", "xinfengwuliu"=> "信丰物流",
               "xingchengjibian"=>"星晨急便", "xinhongyukuaidi"=>"鑫飞鸿", "neweggozzo"=>"新蛋奥硕物流", "hkpost"=>"香港邮政", "yuantong"=>"圆通速递",
               "yunda"=>"韵达快运", "yuntongkuaidi"=> "运通快递", "yuanchengwuliu"=>"远成物流", "yafengsudi"=>"亚风速递", "yibangwuliu"=> "一邦速递", "yuanweifeng"=>"源伟丰快递",
               "yuanzhijiecheng"=>"元智捷诚", "yuefengwuliu"=>"越丰物流", "yuananda"=>"源安达", "yuanfeihangwuliu"=>"原飞航", "zhongxinda"=>"忠信达快递", "yinjiesudi"=>"银捷速递",
               "yitongfeihong"=>"一统飞鸿", "zhongtong"=>"中通速递", "zhaijisong"=>"宅急送", "zhongyouwuliu"=>"中邮物流", "zhongsukuaidi"=>"中速快件", "zhimakaimen"=>"芝麻开门",
               "zhengzhoujianhua"=>"郑州建华", "zhongtianwanyun"=>"中天万运"}

    GuoJi_Company = {"auspost" => "澳大利亚邮政", "aramex" => "Aramex", "bpost" => "比利时邮政", "bpostinter" => "比利时邮政国际件", "canpost" => "加拿大邮政", "canpostfr" => "加拿大邮政", "citylink" => "City-Link", "emsen" => "EMS-（中国-中国）件-英文",
               "fedex" => "Fedex-国际件", "fedexcn" => "Fedex-中国件", "fedexus" => "Fedex-美国件", "dhlen" => "DHL-国际件", "haiwaihuanqiu"=>"海外环球", "lianbangkuaidien" => "Fedex-中国件-英文", "shunfengen"=>"顺丰-英文","cces" => "希伊艾斯（CCES）", "aae" => "AAE", 
               "dpex" => "DPEX", "dpexen" => "DPEX", "dhl" => "DHL-中国件", "dhlde" => "DHL-德国件", "ems" => "EMS-（中国-中国）件",
               "emsguoji" => "EMS-（中国-国际）件", "emsinten" => "EMS-（中国-国际）件-英文", "gls" => "GLS", "hkpost" => "香港邮政", "ruidianyouzheng" => "瑞典邮政包裹小包", "singpost" => "新加坡邮政包裹小包", "tnt" => "TNT-中文", "tnten" => "TNT-英文",
               "ups" => "UPS-中文", "upsen" => "UPS-英文", "usps" => "USPS", "youzhengguonei" => "邮政包裹、挂号信-中国件", "youzhengguoji" => "邮政包裹、挂号信-国际件", "zhongyouwuliu" => "中邮物流"}
  end
end


